module dispatch_snapshot_m

  implicit none

contains

  subroutine dispatch_snapshot(s, unit_isolated, unit_number_eddies, k, m, &
       k_begin, max_delta)

    use derived_types, only: snapshot
    use send_snapshot_m, only: send_snapshot

    type(snapshot), intent(in):: s

    integer, intent(in):: unit_isolated
    ! logical unit for file isolated_nodes_$m.csv

    integer, intent(in):: unit_number_eddies
    ! logical unit for file number_eddies_$m.csv

    integer, intent(in):: k ! date index
    integer, intent(in):: m, k_begin, max_delta

    ! Local:
    integer i

    !------------------------------------------------------------------

    if (m == 1 .or. k >= k_begin + max_delta) then
       do i = 1, s%number_vis_extr
          if (s%list_vis(i)%valid .and. s%list_vis(i)%delta_in == huge(0) &
               .and. s%list_vis(i)%delta_out == huge(0)) &
               write(unit_isolated, fmt = *) k, i
       end do

       write(unit_number_eddies, fmt = *) k, s%number_vis_extr, &
            s%number_eddies - s%number_vis_extr
    else
       call send_snapshot(s, tag = k, dest = m - 1)
    end if

  end subroutine dispatch_snapshot

end module dispatch_snapshot_m
